Page MenuHome

macOS screen scaling wrong on startup
Open, NormalPublic

Description

System Information
OSX Mojave

Blender Version
Broken: 2.79 and 2.80 dailies
Worked: Previous OS's

Short description of error
On Dual Screen setup (5k and 1920x1200) Opening blender on 2nd screen has wrong scaling
Btw. this has nothing to do with the fixed/closed task T56909 (I THINK ;-)

Exact steps for others to reproduce the error
My normal working screen is the 5k screen (on display scaling Default which simulates 2560x1440 according to Apple)
So my default startup.blend has quite a large interface (larger than 1920x1200)
When I open blender on the secondary (smaller!) screen I see this:


Dragging the window to the primary screen makes everything right again.

I've never seen this on previous OS's.. Blender just maximises my setup and shows correctly on the smaller screen if started from there.

Thanks for looking into it.
Roel

Event Timeline

Bastien Montagne (mont29) lowered the priority of this task from Needs Triage by Developer to Normal.Oct 14 2018, 9:19 PM
Brecht Van Lommel (brecht) triaged this task as Needs Information from User priority.Oct 23 2018, 12:10 PM

Does this happen with the buildbot build, or is it your own build?

Does the interface snap back to the right size when resizing or maximizing/minimizing the window? If so it might be similar to T56909, some kind of regression/change in the new macOS SDK with initialization of OpenGL views.

Roel Koster (kostex) raised the priority of this task from Needs Information from User to Normal.Nov 1 2018, 8:34 AM

It happens on both my own as well as the daily builds.
It goes away when I set my "screens have separate spaces" off so I did that in the meantime, but it's not the solution I know.

Did some further testing:
The screen stays scaled wrong, no matter if I resize/maximize:


As soon as I drag the window over to the HIDPi screen it instantly corrects the contents. Dragging it back to the low DPi screen has no negative effect.. It scales ok.

Brecht Van Lommel (brecht) merged a task: Restricted Maniphest Task.Nov 22 2018, 4:50 PM

I have this issue on the following system ( laptop, macbook pro 2015 ->

) which has only one screen! I'd be grateful of any advice for a workaround :) As of today I am using blender 2.80.34 and this is the result I see when opening blender's ui

Curiously enough just discovered that this problem doesn't exist in the preferences window. The scaling and mouse pointer are all aligned properly if I open the user preferences, but remain incorrectly scaled in the main ui

I've been using MacOS 10.14.2 Beta (18C52a) and Blender 2.8 latest beta, and I am not having this display shrinkage issue. I did have similar issue in the past, that's fixed when I maximize Blender.... However, I did saw your computer having this issue tonight, so I am slightly confused. I thought it was the Display Preferences, might be something else....

Let's keep this issue open for now.

For me it reproduces on 10.14.1 with the latest beta pretty easily. It mostly reproduce when I'm on the native laptop screen (Macbook Pro 13") - when connected to the external display it works properly most of the time

Still very much happening, and happening consistently on iMac Pro. Is completely unusable on this machine with just a single monitor.

Ok, I have solved the issue on my MacBook pro 2015 model by starting blender (version 2.80.39) with the option --no-native-pixels. The ui is now fully filling the window its rendered in and the mouse pointer is no longer rendered offset from its position as given by the events system. But the display is butt ugly, no more retina resolution for me. Its rendering at a lower resolution now. At least it is usable, but I don't like how it looks now. So I'd say we should still keep this issue open, esp since its not immediately obvious to the average mac user (feel like I should include myself in that category by the way) that the no native pixels setting is the answer to this problem.

Further it requires you to use terminal and set a command line option. Not sure if everyone would be happy with that.

Same thing has been happening for me on Mojave for ages. Still happening with the daily build and my local build for 2.79. Does not happen for 2.8. I have the most recent 2018 MacBook Pro running Mojave. It happens whether or not I'm just using the laptop screen or if I hook up an external thunderbolt display with or without screen mirroring. If there is any more info I can provide I am happy to help by debugging in Xcode on my system live or whatever. Just tell me what you need. It basically forces me to run Blender 2.79 on my Windows system, which makes me sad.

Most useful would be if someone can figure out what exactly causes this, if it's related to a specific system configuration, settings, or something. I can't reproduce it on my macbook.

I had the same issue, and realized that I usually work with my display resolution (MacOS Settings > Display) set to scaled for more space. This seemed to work for me:

  • Change display resolution back to Default for display
  • Back in Blender, reload the startup file and save it (may be optional if it's just one setting, but worked for me)
  • Can now change the display resolution back to scaled, and the effect doesn't reappear.

I do notice that after the fix blender still won't start at full window size. It starts down in the corner like before, but without the frame stretched and mouse inputs off. So at least it's usable.

Hope this helps!

STR:

  1. Start Blender while laptop is connected to another monitor
  2. Tell laptop to go to sleep
  3. Disconnect from 2nd monitor
  4. Connect to a different monitor
  5. Wake it up

I had the same issue, and realized that I usually work with my display resolution (MacOS Settings > Display) set to scaled for more space. This seemed to work for me:

  • Change display resolution back to Default for display
  • Back in Blender, reload the startup file and save it (may be optional if it's just one setting, but worked for me)
  • Can now change the display resolution back to scaled, and the effect doesn't reappear.

I do notice that after the fix blender still won't start at full window size. It starts down in the corner like before, but without the frame stretched and mouse inputs off. So at least it's usable.
Hope this helps!

Thanks for posting this, sadly I tried this and it did not work for me. I still get the scaling issue and displaced mouse pointer :(

Workaround doesn't work here, either, and setting the resolution scaling to "Default for Display" does not fix the problem for me.

Still a problem. But I have a workaround for my particular system at the moment.

  1. Start Blender 2.79 latest build.
  2. Observe display scaling problem
  3. Drag window to the other display
  4. Observe scaling seems to be fixed
  5. Drag window back to desired display
  6. Observe everything working properly
  7. Shrug
Brecht Van Lommel (brecht) renamed this task from Dual Screen Screen scaling/startup to macOS screen scaling wrong on startup.Jan 25 2019, 6:28 PM

Complementing what I can find in memory and relations.
Im not a programmer but i do know how to use the terminal XD

The mouse is offset Also, when it happened was : i was using evee, to render on the viewport simple cameras parented to an object, playing with the nodes. Is also think is a mac Mojave related problem because there is some flickering on other things.
And the mouse is off centred. also with a Bluetooth mouse/keyboard because i was working with a pc user, we tryed, that when we found that pc user has to press "d" while using the grease pencil and macs don't.

Please find the cure

I was able to reproduce this issue now when opening a particular .blend file. I've committed a fix for that case.

Let me know if it still happens in the latest builds.

Roel Koster (kostex) added a comment.EditedJan 28 2019, 7:39 PM

At my end, things are working the way it should now! Thanks

(not using daily builds but building myself)

Hmm, I still am not sure it's working for me.

I downloaded the beta today and tried it out. This is from build blender-2.80.0-git20190128.704b336899dd-x86_64 .

I just put my mac to sleep and logged back in. Another funny thing this time is to get the blender information window open ( typically a click on the menu blender icon ), I had to click in the black area in the upper left part of the window.

Perhaps, I'm testing an older version?

If I moved the blender window to the center of the display, then the black offset happens when I login from sleep.

If I leave the window in the original position the application started in, then I did not see a black offset.

I tried each one of those situation twice. Also, on the mac, in display settings, I had my monitor scaled up. I set it to the default resolution. In both cases, the behavior was the same.

Monitor -- U32J59x Display 61-inch (3840 x 2160) . Its quite a big display so I tend to scale up and want to move the window ... how I stumbled across the issue.

Also, if I go into fullscreen with the blender window, then I do not see the issue.

Hope the feedback helps.

@John Ostrom (macnib) Try with tomorrows build. It was fixed today and the builds are only updated once a day.

Ah, I will try tomorrows build.

I built locally and it works brilliantly now. Thanks! The native pixel stuff on MacOS is quirky. Ironic that I just found a workaround 3 days ago.

I just built it locally too with 33dcf9fa71c7 . This is still not working. The blender-2.80.0-git20190129.957b4547aeeb-x86_64 downloaded beta build does not work for me either.

These builds seem better than before. But the problems start when you tap on the default cube and highlight it orange and then change the window size and move the window. Sometimes this created issues for me. Attached are screenshots for evidence.

Not trying to be a sour grape but just giving feedback. There might be more than one bug happening.

I haven't tested extensively, but at first glance, this seems to fix my problem (though, I rarely change window size and usually use Blender maximized).

Still an issue in 2.80 release. It is important that the second monitor is a different resolution than the primary. I am using Macbook Pro 13 inch with touch bar and a 3840 x 2160 secondary display. Simple steps to reproduce, with pictures:

  1. Expand Blender to fill entire secondary monitor.

  1. Disconnect the secondary monitor. Blender will move back to the primary monitor, But it will not rescale.

  1. Reconnect the secondary monitor. Blender will move back to the secondary monitor, But now it is the scale of the primary monitor.

It would be great to see this issue fixed.

Having the exact same behaviour as @Addison Miller (seaside98).
An additional element might be that my secondary monitor (Dell U2715H) is not supported by macOS High DPI scaling. Just dragging the window to the second screen and bringing it back solves the issue.
But removing the secondary display makes blender unusable

Would be great to see this issue solved.

This happens consistently on my 2015 MBP when moving from the larger 2540 x 1440 to the laptop screen (secondary display). It is especially annoying when I return to the studio in the morning after having scaled down to laptop size and the interface does not expand properly when I drag it back to the primary display. As noted in all of the above comments, it is the responsiveness of the interface scaling that's a problem. It's been a consistent issue for all of the 2.8x builds.

Thanks a ton for taking a look at this! ;-)